#include <vip_core>
#include <sdktools>
#include <sdkhooks>

#pragma newdecls required

#define MPL MAXPLAYERS+1
#define toBool(%0) view_as<bool>(%0)

public char cubeChvirck[] = "physics/glass/glass_impact_bullet4.wav";
static char featureName[] = "HealCube";     // "HealCube"           "<setName>"
static char featureHp[] = "HP";

#include "healcube/entity.sp"
#include "healcube/client.sp"
#include "healcube/config.sp"


Client clientHealSet[MPL];
StringMap presetsMap;
int healthOffset = -1;
bool isRoundEnd;

public Plugin myinfo =
{
    name		=	"[VIP] Heal Cube",
    description	=	"Хилимся, живем...",
    author		=	"nyood",
    version		=	"1.3.0",
    url			=	"discord.gg/ChTyPUGA"
};

public void OnPluginStart()
{
    LoadTranslations("vip-healcube.phrases");
    
    HookEvent("round_start", OnRoundChange, EventHookMode_PostNoCopy);
    HookEvent("round_end", OnRoundChange, EventHookMode_PostNoCopy);

    RegConsoleCmd("sm_healcube", HealCubeActive);
    
    if(VIP_IsVIPLoaded())
        VIP_OnVIPLoaded();
}

public void OnMapStart() {
    healthOffset = FindSendPropInfo("CCSPlayer", "healthOffset");

    SDKHook(GetPlayerResourceEntity(), SDKHook_ThinkPost, OnThinkPost);

    configPackaging(presetsMap);
}

public void OnThinkPost(int ent) {
    if(ent == -1) {
        SDKUnhook(ent, SDKHook_ThinkPost, OnThinkPost);
        return;
    }

    static int currentTime;
    currentTime = GetGameTickCount();

    for(int i = 1, a, b; i <= MaxClients; i++) {
        if(IsClientInGame(i) && isUseFeature(clientHealSet[i]) && (a = getTimer(clientHealSet[i])) != 0) {
            if(currentTime >= a) {
                setStep(clientHealSet[i], 0);
                stopHealing(i);
                continue;
            }

            if(!(b = getStep(clientHealSet[i]))) {
                b = currentTime;
            }

            if(currentTime >= b) {
                stepHealing(i);
                setStep(clientHealSet[i], b + RoundFloat(getTickrate() * getHealDelay(clientHealSet[i]))); 
            }
        }
    }
}

public void VIP_OnVIPLoaded() {	
    VIP_RegisterFeature(featureName, BOOL, TOGGLABLE, OnToogle);
}

public void OnPluginEnd() {	
    VIP_UnregisterMe();
}

public void VIP_OnVIPClientLoaded(int iClient) {
    setUseFeature(clientHealSet[iClient], VIP_IsClientFeatureUse(iClient, featureName));
}

public void OnRoundChange(Event hEvent, const char[] name, bool dontBroadcast) {	

    isRoundEnd = name[6] == 'e';

    if(!isRoundEnd) {
        for(int i = 1; i <= MaxClients; i++) {
            if(isUseFeature(clientHealSet[i])) {
                resetCounter(clientHealSet[i]);
            }
        }
    }	
}

public Action OnToogle(int iClient, const char[] szFeature, VIP_ToggleState eOldStatus, VIP_ToggleState &eNewStatus) {
    if(eOldStatus == eNewStatus)
        return Plugin_Continue;

    Client preset;
    setCounter(preset, getCounter(clientHealSet[iClient])); // baby don't cry

    if(eNewStatus == ENABLED) {
        char szSet[64];
        VIP_GetClientFeatureString(iClient, featureName, szSet, sizeof(szSet));

        if(szSet[0] && presetsMap.GetArray(szSet, preset, sizeof(preset))) {}

        if(VIP_IsClientFeatureUse(iClient, featureHp) && isUseHpModule(preset)) {
            char szMaxHP[16];
            VIP_GetClientFeatureString(iClient, szFeature, szMaxHP, sizeof(szMaxHP));

            TrimString(szMaxHP);
            if(szMaxHP[0]) {
                setBoostedHp(
                    preset, 
                    (szMaxHP[0] == '+' || !szMaxHP[0]) 
                        ? getDefaultHp(preset) + StringToInt(szMaxHP[1]) 
                        : StringToInt(szMaxHP)
                );
            }
        }

    }	

    clientHealSet[iClient] = preset;

    return Plugin_Continue;
}

Action HealCubeActive(int iClient, int iArgs) {
    if(isRoundEnd 
    || !iClient 
    || !IsClientInGame(iClient) 
    || !IsPlayerAlive(iClient) 
    || !isUseFeature(clientHealSet[iClient])) {
        return Plugin_Handled;
    } 

    if(getHealTime(clientHealSet[iClient]) == 0.0
    || getEntityRefIdx(clientHealSet[iClient].particle) != INVALID_ENT_REFERENCE) {
        return Plugin_Handled;
    }
    
    if(getCounter(clientHealSet[iClient]) >= getHealUseCount(clientHealSet[iClient])) {
        PrintToChat(iClient, "%T", "limited", iClient);
        return Plugin_Handled;
    }
        
    float fEntityPos[3];
    GetClientAbsOrigin(iClient, fEntityPos);
    
    int idx;
    if((idx = createCube(clientHealSet[iClient].model, fEntityPos)) == -1) {
        return Plugin_Handled;
    }

    setEntityRefIdx(clientHealSet[iClient].model, EntIndexToEntRef(idx));

    if((idx = createParticle(iClient, clientHealSet[iClient].particle, fEntityPos)) == -1) {
        killEntity(clientHealSet[iClient].model);
        return Plugin_Handled;
    }

    setEntityRefIdx(clientHealSet[iClient].particle, EntIndexToEntRef(idx));

    EmitSoundToClient(iClient, cubeChvirck, _, SNDCHAN_VOICE);
    
    SetEntityMoveType(iClient, MOVETYPE_NONE);

    upCounter(clientHealSet[iClient]);

    setTimer(clientHealSet[iClient], (GetGameTickCount() + RoundFloat(getTickrate() * getHealTime(clientHealSet[iClient]))));    
    return Plugin_Handled;
}

void stopHealing(int iClient) {

    killEntity(clientHealSet[iClient].model);
    killEntity(clientHealSet[iClient].particle);

    if(!iClient)
        return;

    setTimer(clientHealSet[iClient], 0);

    if(!IsClientInGame(iClient) || !IsPlayerAlive(iClient) || isRoundEnd)
        return;

    EmitSoundToClient(iClient, cubeChvirck, _, SNDCHAN_VOICE);

    SetEntityMoveType(iClient, MOVETYPE_WALK);
}

void stepHealing(int iClient) {
    static int hp;
    hp = GetEntData(iClient, healthOffset);

    static bool useModule;
    useModule = isUseHpModule(clientHealSet[iClient]);

    static int stepHp;
    stepHp = getHealSize(clientHealSet[iClient]);

    static int maxHp;
    maxHp = (useModule) ? getBoostedHp(clientHealSet[iClient]) : getDefaultHp(clientHealSet[iClient]);

    hp = ((hp + stepHp) >= maxHp) ? maxHp : hp + stepHp;

    SetEntData(iClient, healthOffset, hp);
}

public Action OnTakeDamage(int victim, int& attacker, int& inflictor, float& damage, int& damagetype) {
    if(attacker 
    && attacker <= MaxClients 
    && isUseFeature(clientHealSet[attacker]) 
    && getTimer(clientHealSet[attacker]) != 0) {
        damage *= getDmg(clientHealSet[attacker]);
        return Plugin_Changed;
    }

    return Plugin_Continue;
}

public void OnClientPutInServer(int iClient) {

    Entity ent;
    setEntityRefIdx(ent, INVALID_ENT_REFERENCE);

    Client preset;
    setModelEntity(preset, ent);
    setParticleEntity(preset, ent);

    clientHealSet[iClient] = preset;   
}

public void OnClientDisconnect(int iClient) {

    if(isUseFeature(clientHealSet[iClient]) && getTimer(clientHealSet[iClient]) != 0) {
        setStep(clientHealSet[iClient], 0);
        stopHealing(iClient);
    }

    SDKUnhook(iClient, SDKHook_OnTakeDamage, OnTakeDamage);
}

stock float getTickrate() {
    return (1/GetTickInterval());
}