void configPackaging(StringMap pack) {
    pack.Clear();
    PrecacheSound(cubeChvirck, true);

    static char path[PLATFORM_MAX_PATH] = "data/vip/modules/healcube.ini";

    if(path[0] == 'd') {
        BuildPath(Path_SM, path, sizeof(path), path);
    }

    if(!FileExists(path)) {
        SetFailState("Where is my config: %s", path);
    }

    KeyValues kv;
    kv = new KeyValues("healcube");

    if(kv.ImportFromFile(path) && kv.GotoFirstSubKey()) {
        char szSection[PLATFORM_MAX_PATH];
        char szKey[PLATFORM_MAX_PATH];

        int stringTable;
        bool state;

        do {
            Client preset;
            
            kv.GetSectionName(szSection, sizeof(szSection));

            setHealTime(    preset,         kv.GetFloat("healTime",     5.0));
            setHealDelay(   preset,         kv.GetFloat("healDelay",    1.0));
            setHealSize(    preset,         kv.GetNum(  "healSize",     5));
            setHealUseCount(preset,         kv.GetNum(  "healUseCount", 2));
            setUseHpModule( preset,  toBool(kv.GetNum(  "useHPModule",  1)));
            setDefaultHp(   preset,         kv.GetNum(  "defaultHP",    100));
            setDmg(         preset,         kv.GetFloat("dmg",          1.0));

            Entity ent;

            // cube
            {
                setEntityName(ent, "prop_dynamic_override");

                kv.GetString("cube", szKey, sizeof(szKey));
                PrecacheModel(szKey, true);

                setEntityModel(ent, szKey);
                setModelEntity(preset, ent);
            }

            // particle
            if(kv.JumpToKey("particle")) {
                setEntityName(ent, "info_particle_system");

                kv.GetString("effect", szKey, sizeof(szKey));
                setEntityModel(ent, szKey);

                setParticleEntity(preset, ent);

                kv.GetString("path", szKey, sizeof(szKey));
                PrecacheGeneric(szKey, true);
                AddFileToDownloadsTable(szKey);

                if((stringTable = FindStringTable("ParticleEffectNames")) != INVALID_STRING_TABLE) {
                    state = LockStringTables(false);
                    AddToStringTable(stringTable, getEntityName(ent));
                    LockStringTables(state);
                }

                kv.GetString("material", szKey, sizeof(szKey));
                if(szKey[0]) {
                    PrecacheGeneric(szKey, true);
                    AddFileToDownloadsTable(szKey);

                    ReplaceString(szKey, sizeof(szKey), ".vtf", ".vmt", false);
                    AddFileToDownloadsTable(szKey);
                }

                kv.GoBack();
            }

            pack.SetArray(szSection, preset, sizeof(preset), true);

            if(kv.JumpToKey("download") && kv.GotoFirstSubKey(false)) {
                do {
                    kv.GetString("", szKey, sizeof(szKey));

                    if(szKey[0]) {
                        AddFileToDownloadsTable(szKey);
                    }

                } while(kv.GotoNextKey(false));

                kv.GoBack();
            }


        } while(kv.GotoNextKey());
    }

    delete kv;
}