enum struct Entity 
{
    int refIdx;
    char name[64];
    char model[PLATFORM_MAX_PATH];	
}

stock int getEntityRefIdx(Entity ent) {
    return ent.refIdx;
}

stock char[] getEntityName(Entity ent) {
    return ent.name;
}

stock char[] getEntityModel(Entity ent) {
    return ent.model;
}

stock int setEntityRefIdx(Entity ent, int value) {
    return ent.refIdx = value;
}

stock void setEntityModel(Entity ent, const char[] model) {
    FormatEx(ent.model, sizeof(ent.model), "%s", model);
}

stock void setEntityName(Entity ent, const char[] name) {
    FormatEx(ent.name, sizeof(ent.name), "%s", name);
}

int createCube(Entity ent, float pos[3]) {
    int index;
    if((index = CreateEntityByName(getEntityName(ent))) == -1) {
        return index;
    }

    SetEntityModel(index, getEntityModel(ent));
    DispatchSpawn(index);
    ActivateEntity(index);
    TeleportEntity(index, pos, NULL_VECTOR, NULL_VECTOR);

    return index;
}

int createParticle(int iClient, Entity ent, float pos[3]) {
    int index;
    if((index = CreateEntityByName(getEntityName(ent))) == -1) {
        return index;
    }

    DispatchKeyValueVector(index, "origin", pos);
    DispatchKeyValue(index, "effect_name", getEntityModel(ent));
    DispatchKeyValue(index, "start_active", "1");
    DispatchSpawn(index);
    ActivateEntity(index);
    SetVariantString("!activator");
    AcceptEntityInput(index, "SetParent", iClient);

    return index;
}

void killEntity(Entity ent) {
    int index;
    if((index = getEntityRefIdx(ent)) == INVALID_ENT_REFERENCE) {
        return;
    }

    setEntityRefIdx(ent, INVALID_ENT_REFERENCE);

    index = EntRefToEntIndex(index);

    if(IsValidEntity(index)) {
        RemoveEntity(index);
    }
}